Unit SF17R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF16R_p, UTSF10_p;

procedure SF17R(X :Real; var BERD :Real; var BEID :Real;
                var AKERD :Real; var AKEID :Real; var IERR :Integer);

implementation

procedure SF17R(X :Real; var BERD :Real; var BEID :Real;
                var AKERD :Real; var AKEID :Real; var IERR :Integer);
var
I :Integer;
ARG,BEI,BER,B1,B2,B3,B4,CON,DC,DCM,DE,DS,DSM,DSQ,R1P,U,UM,V,VM,AKEI,
   R2P,AKER,Z,ZI,ZIM,ZSQ,Z3,Z4 :Real;
D1 :Array [0..8] of Real;
D2 :Array [0..8] of Real;
D3 :Array [0..8] of Real;
D4 :Array [0..8] of Real;
E3 :Array [0..8] of Real;
E4 :Array [0..8] of Real;
const
TEN :Real = 10.0E0;
ONE :Real = 1.0E0;
ZERO :Real = 0.0E0;
HALF :Real = 0.5E0;
SYS005 :Real = 1.5707963267948966192313216916397;
SYS003 :Real = 6.2831853071795864769252867665590;
SYS011 :Real = 0.39269908169872415480783042290994;
SYS029 :Real = 0.70710678118654752440084436210485;
SYS001 :Real = 3.1415926535897932384626433832795;
SYS039 :Real = 0.57721566490153286060651200000;
ZMAX :Real = 119.0E0;
SYS059 :Real = 3.4E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
{   DATA  FORTRAN  }
D1[0] := -1.250605E-06;
D1[1] := 1.701453E-04;
D1[2] := -1.372460E-02;
D1[3] := 0.623473E0;
D1[4] := -14.48452E0;
D1[5] := 150.1755E0;
D1[6] := -565.1403E0;
D1[7] := 542.5347E0;
D1[8] := -62.5E0;
D2[0] := 1.522699E-05;
D2[1] := -1.633110E-03;
D2[2] := 9.991471E-02;
D2[3] := -3.291935E0;
D2[4] := 52.14426E0;
D2[5] := -336.3931E0;
D2[6] := 678.1684E0;
D2[7] := -260.4167E0;
D2[8] := 5.0E0;
D3[0] := 5.232943E-05;
D3[1] := -5.418856E-03;
D3[2] := 0.317742E0;
D3[3] := -9.941240E0;
D3[4] := 147.5145E0;
D3[5] := -872.2191E0;
D3[6] := 1548.485E0;
D3[7] := -477.4306E0;
D3[8] := 5.0E0;
D4[0] := 4.368205E-06;
D4[1] := -5.752042E-04;
D4[2] := 4.462639E-02;
D4[3] := -1.934767E0;
D4[4] := 42.42469E0;
D4[5] := -408.1555E0;
D4[6] := 1384.594E0;
D4[7] := -1130.281E0;
D4[8] := 93.75E0;
E3[0] := -5.63E-08;
E3[1] := -1.671E-07;
E3[2] := -1.47E-08;
E3[3] := 1.9780E-06;
E3[4] := 1.44255E-05;
E3[5] := 7.25024E-05;
E3[6] := -8.0E-10;
E3[7] := -2.651650E-02;
E3[8] := 1.0E0;
E4[0] := -2.69E-08;
E4[1] := -8.83E-08;
E4[2] := -6.992E-07;
E4[3] := -2.0042E-06;
E4[4] := 7.9E-09;
E4[5] := 7.25179E-05;
E4[6] := 1.171874E-03;
E4[7] := 2.651650E-02;
E4[8] := 0.0E0;
IERR := 0;
SF16R(X,BER,BEI,AKER,AKEI,IERR);
Z := Abs(X);
if ( Z > TEN ) 
 then goto _3;
if ( Z = ZERO ) 
 then goto _2;
Z := Z/TEN;
ZSQ := Z*Z;
Z3 := ZSQ*Z;
Z4 := ZSQ*ZSQ;
B1 := D1[0];
B2 := D2[0];
B3 := D3[0];
B4 := D4[0];
for I:=2 to 9 do
 begin
  B1 := B1*Z4+D1[I-1];
  B2 := B2*Z4+D2[I-1];
  B3 := B3*Z4+D3[I-1];
  B4 := B4*Z4+D4[I-1];
_1:
 end;
BERD := B1*Z3;
BEID := Z*B2;
if ( X < ZERO ) 
 then goto _6;
R1P := Z*B3;
R2P := Z3*B4;
CON := (Ln(X*HALF)+SYS039);
V := Abs(X);
AKEID := -SYS005*HALF*BERD+(R1P-BEID*CON-BEI/V);
AKERD := SYS005*HALF*BEID-(R2P+BERD*CON+BER/V);
goto _9;
_2:
BERD := ZERO;
BEID := ZERO;
AKEID := ZERO;
AKERD := -SYS059;
goto _9;
_3:
if ( Z > ZMAX ) 
 then goto _5;
ZI := TEN/Z;
ZIM := -ZI;
U := E3[0];
UM := U;
V := E4[0];
VM := V;
for I:=2 to 9 do
 begin
  U := U*ZI+E3[I-1];
  V := V*ZI+E4[I-1];
  UM := UM*ZIM+E3[I-1];
  VM := VM*ZIM+E4[I-1];
_4:
 end;
ARG := Z*SYS029;
DS := Sin(ARG-SYS011);
DC := Cos(ARG-SYS011);
DSM := Sin(ARG+SYS011);
DCM := Cos(ARG+SYS011);
DE := Exp(ARG);
DSQ := Sqrt(SYS003*Z);
BERD := DE*(U*DCM-V*DSM)/DSQ;
BEID := DE*(V*DCM+U*DSM)/DSQ;
if ( X < ZERO ) 
 then goto _6;
AKEID := -SYS001*(VM*DC-UM*DS)/(DE*DSQ);
AKERD := -SYS001*(UM*DC+VM*DS)/(DE*DSQ);
goto _9;
_5:
BERD := ZERO;
BEID := ZERO;
IERR := 66;
if ( X < ZERO ) 
 then goto _7;
AKEID := ZERO;
AKERD := ZERO;
goto _8;
_6:
IERR := 1;
BERD := -BERD;
BEID := -BEID;
_7:
AKERD := SYS059;
AKEID := SYS059;
if ( IERR = 0 ) 
 then goto _9;
_8:
UTSF10(IERR,17);
_9:
end;

end.
